# DeathRun 2.5
# Created by isivisi
# This plugin is Open-Source
# Please give credit to original creator if modified!
import es,gamethread,popuplib,weaponstrip,cfglib,playerlib,update
from es import server_var

# DEBUG
debug = 0

info = es.AddonInfo()
info.name = 'DeathRun 3'
info.version = '2.5'
info.buildnumber = '912'
info.basename = 'deathrun'
info.url = ''
info.author = 'isivisi'
info.description = 'Gives your server rounds and other cool features for deathrun!'
es.setinfo('b_deathrun_version', '<version: %s build: %s>'%(info.version, info.buildnumber))
es.makepublic('b_deathrun_version')

es.regcmd('add_admin', 'deathrun/addadmin')
es.regcmd('add_vip', 'deathrun/addvip')
es.regcmd('dr_setvariable', 'deathrun/setvar')
#cfg stuff
config = cfglib.AddonCFG(es.getAddonPath("deathrun") + "/deathrun.cfg")
deathrun_defaultteam    = config.cvar("deathrun_defaultteam",     3, "sets the default team for players")
deathrun_autoupdate   = config.cvar("deathrun_autoupdate",   1, "autoupdates")
deathrun_combinelimit      = config.cvar("deathrun_combinelimit",      3, "Limit your combines!")
deathrun_combinelimit_auto    = config.cvar("deathrun_combinelimit_auto",     0, "Let the server limit your combines!")
deathrun_rebel_winlimit  = config.cvar("deathrun_rebel_winlimit",     15, "limit your wins!")
deathrun_combine_winlimit  = config.cvar("deathrun_combine_winlimit",     15, "limit your wins!")
config.write()
config.execute()
#admin cmds
def makeadmincmd(name, returnblock):
	es.regclientcmd('dr_%s'%name, returnblock)
	es.regcmd('dr_%s'%name, '%s_c'%returnblock)
	es.regsaycmd('!%s'%name, returnblock)
makeadmincmd('restart', 'deathrun/restart')
makeadmincmd('setteam', 'deathrun/setteams')
makeadmincmd('forceteam', 'deathrun/forceteam')
makeadmincmd('reset', 'deathrun/resetall')

es.forcevalue('mp_forcerespawn', '1')
es.forcevalue('mp_allowspectators', '1.0')
es.forcevalue('mp_respawnwavetime', '1')
admins = []
teams = {}
vips = []
notify_tell = {'rebel_spec': 'You will join #greenRebels#lightgreen at the end of the round.',
'combine_spec': 'You will join #greenCombine#lightgreen at the end of the round',
'combine_limit': 'You cannot go over the combine limit!',
'admin_fail': 'You do not have access to that command!',
'teams_esc': 'Press #greenEscape#lightgreen then select your team!',
'vip_health': 'Vip #green+50#lightgreen health!',
'setteam_noid': 'Player does not exist!',
'setteam_syntax': 'Syntax: dr_setteam <name> <team> Example: dr_setteam isi r (uses: r, c, s for teams)',
'forceteam_syntax': 'Syntax: dr_forceteam <name> <team> Example: dr_forceteam isi r (uses: r, c, s for teams)'}
notify_say = {'rebel_win': 'Rebels Win!',
'combine_win': 'Combine Win!',
'restart_5': 'Restarting in 5',
'restart_4': 'Restarting in 4',
'restart_3': 'Restarting in 3',
'restart_2': 'Restarting in 2',
'restart_1': 'Restarting in 1',
'restart_0': 'Begin!',
'combine_missing': 'Someone please say #green!teams#lightgreen and join combine!',
'combine_back': 'Server has combine, round restarting!',
'rebel_winmap': 'Rebels have reached maximum score!',
'combine_winmap': 'Combine have reached maximum score!',
'sm_error': 'Sourcemod is not installed on this server! nextmap not available!',
'reset_score': 'The scores have been reset!',
'plugin_start': 'has loaded with version ' + server_var['b_deathrun_version']}
variable = {'win': 1,
'count': 1,
'antirebel': 0,
'scoring': 0,
'rebel_score': 0,
'combine_score': 0,
'spec': 0,
'needcombine': 1,
'wintaken': 0,
'forceteam': 0}
if es.getplayercount() > 0:
	for userid in es.getUseridList():
		teams['%s'%userid] = '3'
		es.server.queuecmd('echo [DeathRun] Error player %s has no team! fixing.'%userid)
def isadmin(userid):
	steamid = es.getplayersteamid(userid)
	if steamid in admins:
		return True
	else:
		return False
def isvip(userid):
	steamid = es.getplayersteamid(userid)
	if steamid in vips:
		return True
	else:
		return False
def addadmin():
	args = es.getargs()
	global admins
	admins.append(args)
	print admins
def addvip():
	args = es.getargs()
	global vips
	vips.append(args)
	print vips
def setteam(userid, team, spawn):
	global teams
	teams['%s'%userid] = team
	if spawn == 1:
		es.cexec(userid, 'jointeam %s'%team)
		es.changeteam(userid, team)
def menuhandler(userid, choice, popupname):
	global teams
	if variable['spec'] == 1:
		if choice == 'r':
			setteam(userid, 3, 0)
			tell_notify(userid, 'rebel_spec')
		elif choice == 'c':
			setteam(userid, 2, 0)
			tell_notify(userid, 'combine_spec')
		elif choice == 's':
			setteam(userid, 1, 1)
	else:
		if choice == 'r':
			setteam(userid, 3, 1)
		elif choice == 'c':
			setteam(userid, 2, 1)
		elif choice == 's':
			setteam(userid, 1, 1)
myPopup = popuplib.easymenu('Team_Select',None, menuhandler)
myPopup.settitle("Select Team:")

myPopup.addoption('r', "Rebels")
myPopup.addoption('c', "Combine")
myPopup.addoption('s', "Spec")
def unload():
	myPopup.delete()
def es_map_start(ev):
	global variable,admins
	variable['spec'] = 0
	variable['needcombine'] = 1
	variable['win'] = 1
	variable['rebel_score'] = 0
	variable['combine_score'] = 0
	del admins
	admins = []
	es.server.queuecmd('exec deathrun')
	if deathrun_autoupdate == 1:
		update.check()
def player_say(ev):
	if ev['text'] == '!teams':
		tell_notify(ev['userid'], 'teams_esc')
		myPopup.send(ev['userid'])
def tell_notify(userid, text):
	es.tell(userid, '#multi', '#green[Deathrun]#lightgreen %s'%notify_tell[text])
def player_spawn(ev):
	global variable,deathrun_combinelimit
	es.setplayerprop(ev["userid"], "CBaseEntity.m_CollisionGroup", "2")
	if deathrun_combinelimit_auto == 1:
		players = es.getplayercount()
		if players <= 5:
			deathrun_combinelimit = 1
		elif players > 5 and players < 10:
			deathrun_combinelimit = 3
		elif players > 9 and players < 20:
			deathrun_combinelimit = 5
	weaponstrip.removeweps(.5)
	playerlib.getPlayer(ev['userid']).health = 9999
	if isvip(ev['userid']) == False:
		gamethread.delayed(3, sethealth, (ev['userid'], '100'))
	else:
		tell_notify(ev['userid'], 'vip_health')
		gamethread.delayed(3, sethealth, (ev['userid'], '150'))
	if ev['es_userteam'] == '3':
		gamethread.delayed(.6, es.sexec, (ev['userid'], 'use weapon_crowbar'))
	elif ev['es_userteam'] == '2':
		gamethread.delayed(.6, es.sexec, (ev['userid'], 'use weapon_stunstick'))
	if es.getlivingplayercount(2) == 0:
		variable['needcombine'] = 1
		variable['spec'] = 0
		variable['win'] = 0
		variable['scoring'] = 0
		notify('combine_missing')
	if variable['needcombine'] == 1:
		for useridz in es.getUseridList():
			if teams['%s'%useridz] == 2:
				notify('combine_back')
				forcesettings()
				restartround()
				variable['needcombine'] = 0
def forcesettings():
	global variable
	if variable['win'] == 0:
		if debug == 1:
			print 'forcesettings: win 1'
			print 'forcesettings: scoring 1'
			print 'forcesettings: wintaken 0'
		variable['win'] = 1
		variable['scoring'] = 1
		variable['wintaken'] = 0
def sethealth(userid, health):
	playerlib.getPlayer(userid).health = health
def player_activate(ev):
	global teams
	try:
		if teams[ev['userid']] == 'lol':
			placeholder = 'lol'
	except:
		teams[ev['userid']] = '%s'%deathrun_defaultteam
def notify(arg):
	es.msg('#multi', '#green[DeathRun]#lightgreen %s' % notify_say[arg])
def restartround():
	global variable
	if variable['count'] == 1:
		es.server.queuecmd('mp_restartgame 5')
		notify('restart_5')
		variable['win'] = 0
		variable['spec'] = 0
		variable['count'] = 0
		gamethread.delayed(1, fx1, 'lol')
		gamethread.delayed(1, notify, 'restart_4')
		gamethread.delayed(2, notify, 'restart_3')
		gamethread.delayed(3, notify, 'restart_2')
		gamethread.delayed(4, notify, 'restart_1')
		gamethread.delayed(5, notify, 'restart_0')
		gamethread.delayed(5, loadteams, '0')
		gamethread.delayed(6, loadteams, '0')
		gamethread.delayed(7, loadteams, '0')
		gamethread.delayed(8, finish, '0')
def fx1(lol):
	global variable
	variable['scoring'] = 0
def finish(lol):
	global variable
	if variable['needcombine'] != 1:
		variable['spec'] = 1
		variable['win'] = 1
		variable['scoring'] = 1
		variable['antirebel'] = 0
	variable['wintaken'] = 0
	variable['count'] = 1
def setvar():
	global variable
	variable[es.getargv(1)] = int(es.getargv(2))
def loadteams(place):
	for userid in es.getUseridList():
		setteam(userid, teams['%s'%userid], 1)
def player_team(ev):
	global teams,variable
	if ev['team'] == '3' and ev['oldteam'] == '2':
		variable['antirebel'] = 1
	if es.getplayercount(2) >= deathrun_combinelimit:
		tell_notify(ev['userid'], 'combine_limit')
	if variable['spec'] == 1 and variable['forceteam'] == 0:
		es.cexec(ev['userid'], 'jointeam 1')
		es.changeteam(ev['userid'], 1)
	else:
		try:
			if teams[ev['userid']] == 'test':
				placeholder = 'lol'
		except:
			setteam(ev['userid'], deathrun_defaultteam, 1)
def player_death(ev):
	global variable
	if variable['spec'] == 1:
		es.changeteam(ev['userid'], 1)
		es.cexec(ev['userid'], 'jointeam 1')
	if variable['win'] == 1:
		if variable['wintaken'] == 0:
			if es.getlivingplayercount(2) == 0:
				gamethread.delayed(.5, pd2, 2)
				notify('rebel_win')
				restartround()
				if variable['scoring'] == 1:
					if variable['antirebel'] == 0:
						variable['rebel_score'] += 1
						es.msg('#multi', '#green[DeathRun]#lightgreen Rebels: %s/%s Combine %s/%s'%(variable['rebel_score'], deathrun_rebel_winlimit, variable['combine_score'], deathrun_combine_winlimit))
						if variable['rebel_score'] == deathrun_rebel_winlimit:
							gameend('rebels')
		if variable['wintaken'] == 0:
			if es.getlivingplayercount(3) == 0:
				gamethread.delayed(.5, pd2, 2)
				notify('combine_win')
				restartround()
				if variable['scoring'] == 1:
					if variable['antirebel'] == 0:
						variable['combine_score'] += 1
						es.msg('#multi', '#green[DeathRun]#lightgreen Rebels: %s/%s Combine %s/%s'%(variable['rebel_score'], deathrun_rebel_winlimit, variable['combine_score'], deathrun_combine_winlimit))
						if variable['combine_score'] == deathrun_combine_winlimit:
							gameend('combine')
def pd2(lol):
	if lol == 2:
		variable['wintaken'] = 1
		variable['win'] = 0
	elif lol == 1:
		variable['wintaken'] = 1
def gameend(team):
	if team == 'rebels':
		notify('rebel_winmap')
		if server_var['sm_nextmap'] != '0':
			gamethread.delayed(5, es.server.queuecmd, 'es changelevel server_var(sm_nextmap)')
		else:
			notify('sm_error')
			reset_score()
	if team == 'combine':
		notify('combine_winmap')
		if server_var['sm_nextmap'] != '0':
			gamethread.delayed(5, es.server.queuecmd, 'es changelevel server_var(sm_nextmap)')
		else:
			notify('sm_error')
			reset_score()
def reset_score():
	global variable
	variable['rebel_score'] = 0
	variable['combine_score'] = 0
	notify('reset_score')
def admin_notify(userid, say, tell, tell_userid, team):
	notify_admin = {'restart': 'restarted the round',
	'reset': 'reset the score',
	'setteam': 'set your team to ' + team}
	if tell == 0:
		es.msg('#multi', '#green[DeathRun]#lightgreen Admin #green%s#lightgreen %s'%(es.getplayername(userid), notify_admin[say]))
	else:
		es.tell(tell_userid, '#multi', '#green[DeathRun]#lightgreen Admin %s %s'%(es.getplayername(userid), notify_admin[say]))
def restart():
	if isadmin(es.getcmduserid()) == True:
		admin_notify(es.getcmduserid(), 'restart', 0, es.getcmduserid(), 'team')
		restartround()
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def restart_c():
	restartround()
def resetall_c():
	reset_score()
def resetall():
	if isadmin(es.getcmduserid()) == True:
		admin_notify(es.getcmduserid(), 'reset', 0, es.getcmduserid(), 'team')
		reset_score()
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def setteams():
	if isadmin(es.getcmduserid()) == True:
		if es.getargv(1) and es.getargv(2):
			player_userid = es.getuserid(es.getargv(1))
			if player_userid:
				if es.getargv(2) == 'r':
					setteam(player_userid, 3, 1)
					admin_notify(player_userid, 'setteam', 1, es.getcmduserid(), 'rebels')
				if es.getargv(2) == 'c':
					setteam(player_userid, 2, 1)
					admin_notify(player_userid, 'setteam', 1, es.getcmduserid(), 'combine')
				if es.getargv(2) == 's':
					setteam(player_userid, 1, 1)
					admin_notify(player_userid, 'setteam', 1, es.getcmduserid(), 'spec')
			else:
				tell_notify(es.getcmduserid(), 'setteam_noid')
		else:
			tell_notify(es.getcmduserid(), 'setteam_syntax')
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def setteams_c():
	player_userid = es.getuserid(es.getargv(1))
	if player_userid:
		if es.getargv(2) == 'r':
			setteam(player_userid, 3, 1)
		if es.getargv(2) == 'c':
			setteam(player_userid, 2, 1)
		if es.getargv(2) == 's':
			setteam(player_userid, 1, 1)
def forceteam_c():
	player_userid = es.getuserid(es.getargv(1))
	if player_userid:
		if es.getargv(2) == 'r':
			setteam(player_userid, 3, 1)
		if es.getargv(2) == 'c':
			setteam(player_userid, 2, 1)
		if es.getargv(2) == 's':
			setteam(player_userid, 1, 1)
		variable['forceteam'] == 1
		gamethread.delayed(.5, forceteamfinish, 'lol')
def forceteam():
	global variable
	if isadmin(es.getcmduserid()) == True:
		if es.getargv(1) and es.getargv(2):
			player_userid = es.getuserid(es.getargv(1))
			if player_userid:
				if es.getargv(2) == 'r':
					setteam(player_userid, 3, 1)
					admin_notify(player_userid, 'setteam', 1, es.getcmduserid(), 'rebels')
				if es.getargv(2) == 'c':
					setteam(player_userid, 2, 1)
					admin_notify(player_userid, 'setteam', 1, es.getcmduserid(), 'combine')
				if es.getargv(2) == 's':
					setteam(player_userid, 1, 1)
					admin_notify(player_userid, 'setteam', 1, es.getcmduserid(), 'spec')
				variable['forceteam'] == 1
				gamethread.delayed(.5, forceteamfinish, 'lol')
			else:
				tell_notify(es.getcmduserid(), 'setteam_noid')
		else:
			tell_notify(es.getcmduserid(), 'forceteam_syntax')
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def forceteamfinish(lol):
	global variable
	variable['forceteam'] = 0
	
notify('plugin_start')
restartround()
if deathrun_autoupdate == 1:
	update.check()
